#include "php_gtk.h"
#if HAVE_PHP_GTK

#include <gtkextra/gtkextra.h>
#include "ext/gtk+/php_gtk+.h"
#include <gtkextra/gtkitementry.h>

void php_extra_register_constants(int module_number TSRMLS_DC)
{

	/* enum  */
	REGISTER_LONG_CONSTANT("GTK_PLOT_GRADIENT_H", GTK_PLOT_GRADIENT_H, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_GRADIENT_V", GTK_PLOT_GRADIENT_V, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_GRADIENT_S", GTK_PLOT_GRADIENT_S, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotScale */
	REGISTER_LONG_CONSTANT("GTK_PLOT_SCALE_LINEAR", GTK_PLOT_SCALE_LINEAR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SCALE_LOG10", GTK_PLOT_SCALE_LOG10, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotSymbolType */
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_NONE", GTK_PLOT_SYMBOL_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_SQUARE", GTK_PLOT_SYMBOL_SQUARE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_CIRCLE", GTK_PLOT_SYMBOL_CIRCLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_UP_TRIANGLE", GTK_PLOT_SYMBOL_UP_TRIANGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_DOWN_TRIANGLE", GTK_PLOT_SYMBOL_DOWN_TRIANGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_RIGHT_TRIANGLE", GTK_PLOT_SYMBOL_RIGHT_TRIANGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_LEFT_TRIANGLE", GTK_PLOT_SYMBOL_LEFT_TRIANGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_DIAMOND", GTK_PLOT_SYMBOL_DIAMOND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_PLUS", GTK_PLOT_SYMBOL_PLUS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_CROSS", GTK_PLOT_SYMBOL_CROSS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_STAR", GTK_PLOT_SYMBOL_STAR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_DOT", GTK_PLOT_SYMBOL_DOT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_IMPULSE", GTK_PLOT_SYMBOL_IMPULSE, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotSymbolStyle */
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_EMPTY", GTK_PLOT_SYMBOL_EMPTY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_FILLED", GTK_PLOT_SYMBOL_FILLED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_SYMBOL_OPAQUE", GTK_PLOT_SYMBOL_OPAQUE, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotBorderStyle */
	REGISTER_LONG_CONSTANT("GTK_PLOT_BORDER_NONE", GTK_PLOT_BORDER_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_BORDER_LINE", GTK_PLOT_BORDER_LINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_BORDER_SHADOW", GTK_PLOT_BORDER_SHADOW, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotLineStyle */
	REGISTER_LONG_CONSTANT("GTK_PLOT_LINE_NONE", GTK_PLOT_LINE_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LINE_SOLID", GTK_PLOT_LINE_SOLID, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LINE_DOTTED", GTK_PLOT_LINE_DOTTED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LINE_DASHED", GTK_PLOT_LINE_DASHED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LINE_DOT_DASH", GTK_PLOT_LINE_DOT_DASH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LINE_DOT_DOT_DASH", GTK_PLOT_LINE_DOT_DOT_DASH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LINE_DOT_DASH_DASH", GTK_PLOT_LINE_DOT_DASH_DASH, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotConnector */
	REGISTER_LONG_CONSTANT("GTK_PLOT_CONNECT_NONE", GTK_PLOT_CONNECT_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CONNECT_STRAIGHT", GTK_PLOT_CONNECT_STRAIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CONNECT_SPLINE", GTK_PLOT_CONNECT_SPLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CONNECT_HV_STEP", GTK_PLOT_CONNECT_HV_STEP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CONNECT_VH_STEP", GTK_PLOT_CONNECT_VH_STEP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CONNECT_MIDDLE_STEP", GTK_PLOT_CONNECT_MIDDLE_STEP, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotLabelPos */
	REGISTER_LONG_CONSTANT("GTK_PLOT_LABEL_NONE", GTK_PLOT_LABEL_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LABEL_IN", GTK_PLOT_LABEL_IN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LABEL_OUT", GTK_PLOT_LABEL_OUT, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotError */
	REGISTER_LONG_CONSTANT("GTK_PLOT_ERROR_DIV_ZERO", GTK_PLOT_ERROR_DIV_ZERO, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotOrientation */
	REGISTER_LONG_CONSTANT("GTK_PLOT_AXIS_X", GTK_PLOT_AXIS_X, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_AXIS_Y", GTK_PLOT_AXIS_Y, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_AXIS_Z", GTK_PLOT_AXIS_Z, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotAxisPos */
	REGISTER_LONG_CONSTANT("GTK_PLOT_AXIS_LEFT", GTK_PLOT_AXIS_LEFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_AXIS_RIGHT", GTK_PLOT_AXIS_RIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_AXIS_TOP", GTK_PLOT_AXIS_TOP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_AXIS_BOTTOM", GTK_PLOT_AXIS_BOTTOM, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotLabelStyle */
	REGISTER_LONG_CONSTANT("GTK_PLOT_LABEL_FLOAT", GTK_PLOT_LABEL_FLOAT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LABEL_EXP", GTK_PLOT_LABEL_EXP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_LABEL_POW", GTK_PLOT_LABEL_POW, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotTicksPos */
	REGISTER_LONG_CONSTANT("GTK_PLOT_TICKS_NONE", GTK_PLOT_TICKS_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_TICKS_IN", GTK_PLOT_TICKS_IN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_TICKS_OUT", GTK_PLOT_TICKS_OUT, CONST_CS | CONST_PERSISTENT);

	/* enum  */
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_CAN_SELECT", GTK_PLOT_CANVAS_CAN_SELECT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_CAN_SELECT_ITEM", GTK_PLOT_CANVAS_CAN_SELECT_ITEM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_CAN_SELECT_POINT", GTK_PLOT_CANVAS_CAN_SELECT_POINT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_CAN_DND", GTK_PLOT_CANVAS_CAN_DND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_CAN_DND_POINT", GTK_PLOT_CANVAS_CAN_DND_POINT, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotCanvasAction */
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_ACTION_INACTIVE", GTK_PLOT_CANVAS_ACTION_INACTIVE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_ACTION_SELECTION", GTK_PLOT_CANVAS_ACTION_SELECTION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_ACTION_DRAG", GTK_PLOT_CANVAS_ACTION_DRAG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_ACTION_RESIZE", GTK_PLOT_CANVAS_ACTION_RESIZE, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotCanvasFlag */
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_FROZEN", GTK_PLOT_CANVAS_FROZEN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_CAN_MOVE", GTK_PLOT_CANVAS_CAN_MOVE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_CAN_X_RESIZE", GTK_PLOT_CANVAS_CAN_X_RESIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_CAN_Y_RESIZE", GTK_PLOT_CANVAS_CAN_Y_RESIZE, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotCanvasArrow */
	REGISTER_LONG_CONSTANT("GTK_PLOT_ARROW_NONE", GTK_PLOT_ARROW_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_ARROW_ORIGIN", GTK_PLOT_ARROW_ORIGIN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_ARROW_END", GTK_PLOT_ARROW_END, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotCanvasSelection */
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_SELECT_NONE", GTK_PLOT_CANVAS_SELECT_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_SELECT_MARKERS", GTK_PLOT_CANVAS_SELECT_MARKERS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_SELECT_TARGET", GTK_PLOT_CANVAS_SELECT_TARGET, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotCanvasSelectionMode */
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_SELECT_CLICK_1", GTK_PLOT_CANVAS_SELECT_CLICK_1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_SELECT_CLICK_2", GTK_PLOT_CANVAS_SELECT_CLICK_2, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotCanvasType */
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_NONE", GTK_PLOT_CANVAS_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_PLOT", GTK_PLOT_CANVAS_PLOT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_AXIS", GTK_PLOT_CANVAS_AXIS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_LEGENDS", GTK_PLOT_CANVAS_LEGENDS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_TITLE", GTK_PLOT_CANVAS_TITLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_TEXT", GTK_PLOT_CANVAS_TEXT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_DATA", GTK_PLOT_CANVAS_DATA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_LINE", GTK_PLOT_CANVAS_LINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_RECTANGLE", GTK_PLOT_CANVAS_RECTANGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_ELLIPSE", GTK_PLOT_CANVAS_ELLIPSE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_PIXMAP", GTK_PLOT_CANVAS_PIXMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_MARKER", GTK_PLOT_CANVAS_MARKER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_CUSTOM", GTK_PLOT_CANVAS_CUSTOM, CONST_CS | CONST_PERSISTENT);

	/* enum GtkPlotCanvasPos */
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_OUT", GTK_PLOT_CANVAS_OUT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_IN", GTK_PLOT_CANVAS_IN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_LEFT", GTK_PLOT_CANVAS_LEFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_RIGHT", GTK_PLOT_CANVAS_RIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_TOP", GTK_PLOT_CANVAS_TOP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_BOTTOM", GTK_PLOT_CANVAS_BOTTOM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_TOP_LEFT", GTK_PLOT_CANVAS_TOP_LEFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_TOP_RIGHT", GTK_PLOT_CANVAS_TOP_RIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_BOTTOM_LEFT", GTK_PLOT_CANVAS_BOTTOM_LEFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_PLOT_CANVAS_BOTTOM_RIGHT", GTK_PLOT_CANVAS_BOTTOM_RIGHT, CONST_CS | CONST_PERSISTENT);

	/* enum GtkSheetAttrType */
	REGISTER_LONG_CONSTANT("GTK_SHEET_FOREGROUND", GTK_SHEET_FOREGROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_BACKGROUND", GTK_SHEET_BACKGROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_FONT", GTK_SHEET_FONT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_JUSTIFICATION", GTK_SHEET_JUSTIFICATION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_BORDER", GTK_SHEET_BORDER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_BORDER_COLOR", GTK_SHEET_BORDER_COLOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_IS_EDITABLE", GTK_SHEET_IS_EDITABLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_IS_VISIBLE", GTK_SHEET_IS_VISIBLE, CONST_CS | CONST_PERSISTENT);

	/* enum  */
	REGISTER_LONG_CONSTANT("GTK_SHEET_IS_LOCKED", GTK_SHEET_IS_LOCKED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_IS_FROZEN", GTK_SHEET_IS_FROZEN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_IN_XDRAG", GTK_SHEET_IN_XDRAG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_IN_YDRAG", GTK_SHEET_IN_YDRAG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_IN_DRAG", GTK_SHEET_IN_DRAG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_IN_SELECTION", GTK_SHEET_IN_SELECTION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_IN_RESIZE", GTK_SHEET_IN_RESIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_IN_CLIP", GTK_SHEET_IN_CLIP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_ROW_FROZEN", GTK_SHEET_ROW_FROZEN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_COLUMN_FROZEN", GTK_SHEET_COLUMN_FROZEN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_AUTORESIZE", GTK_SHEET_AUTORESIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_CLIP_TEXT", GTK_SHEET_CLIP_TEXT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_ROW_TITLES_VISIBLE", GTK_SHEET_ROW_TITLES_VISIBLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_COL_TITLES_VISIBLE", GTK_SHEET_COL_TITLES_VISIBLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_AUTO_SCROLL", GTK_SHEET_AUTO_SCROLL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GTK_SHEET_JUSTIFY_ENTRY", GTK_SHEET_JUSTIFY_ENTRY, CONST_CS | CONST_PERSISTENT);


REGISTER_LONG_CONSTANT("GTK_TYPE_ITEM_ENTRY", GTK_TYPE_ITEM_ENTRY, CONST_CS | CONST_PERSISTENT);
}

PHP_GTK_EXPORT_CE(gtk_sheet_range_ce);
PHP_GTK_EXPORT_CE(gtk_plot_ce);
PHP_GTK_EXPORT_CE(gtk_plotcanvas_ce);
PHP_GTK_EXPORT_CE(gtk_plotdata_ce);
PHP_GTK_EXPORT_CE(gtk_plotaxis_ce);
PHP_GTK_EXPORT_CE(gtk_sheet_ce);

/* struct GtkSheetRange */

zval *PHP_GTK_EXPORT_FUNC(php_gtk_sheet_range_new)(GtkSheetRange *obj)
{
	zval *result;
	TSRMLS_FETCH();

    if (!obj) {
        MAKE_STD_ZVAL(result);
        ZVAL_NULL(result);
        return result;
    }

    MAKE_STD_ZVAL(result);
    object_init_ex(result, gtk_sheet_range_ce);

	add_property_long(result, "row0", obj->row0);
	add_property_long(result, "col0", obj->col0);
	add_property_long(result, "rowi", obj->rowi);
	add_property_long(result, "coli", obj->coli);

    return result;
}


zend_bool PHP_GTK_EXPORT_FUNC(php_gtk_sheet_range_get)(zval *wrapper, GtkSheetRange *obj)
{
    zval **item;
	TSRMLS_FETCH();

    if (!php_gtk_check_class(wrapper, gtk_sheet_range_ce))
        return 0;

	if (zend_hash_find(Z_OBJPROP_P(wrapper), "row0", sizeof("row0"), (void **)&item) == SUCCESS && Z_TYPE_PP(item) == IS_LONG)
		obj->row0 = (gint)Z_LVAL_PP(item);
	else
		return 0;

	if (zend_hash_find(Z_OBJPROP_P(wrapper), "col0", sizeof("col0"), (void **)&item) == SUCCESS && Z_TYPE_PP(item) == IS_LONG)
		obj->col0 = (gint)Z_LVAL_PP(item);
	else
		return 0;

	if (zend_hash_find(Z_OBJPROP_P(wrapper), "rowi", sizeof("rowi"), (void **)&item) == SUCCESS && Z_TYPE_PP(item) == IS_LONG)
		obj->rowi = (gint)Z_LVAL_PP(item);
	else
		return 0;

	if (zend_hash_find(Z_OBJPROP_P(wrapper), "coli", sizeof("coli"), (void **)&item) == SUCCESS && Z_TYPE_PP(item) == IS_LONG)
		obj->coli = (gint)Z_LVAL_PP(item);
	else
		return 0;


    return 1;
}


PHP_FUNCTION(gtksheetrange)
{
	long row0, col0, rowi, coli;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iiii", &row0, &col0, &rowi, &coli)) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	add_property_long(this_ptr, "row0", row0);
	add_property_long(this_ptr, "col0", col0);
	add_property_long(this_ptr, "rowi", rowi);
	add_property_long(this_ptr, "coli", coli);
}


static function_entry php_gtk_sheet_range_functions[] = {
	{"GtkSheetRange",	PHP_FN(gtksheetrange),	NULL},
	{"gtksheetrange",	PHP_FN(gtksheetrange),	NULL},
	{NULL, NULL, NULL}
};


/* object GtkPlot  */

PHP_FUNCTION(gtk_plot_new_with_size)
{
	GdkDrawable *drawable = NULL;
	zval *php_drawable = NULL;
	double width, height;
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "|Vdd", &php_drawable, &width, &height)) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	if (php_drawable) {
		if (Z_TYPE_P(php_drawable) == IS_NULL)
			drawable = NULL;
		else if (php_gtk_check_class(php_drawable, gdk_window_ce))
			drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
		else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
			drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
		else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
			drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
	}
	wrapped_obj = (GtkObject *)gtk_plot_new_with_size(drawable, (float)width, (float)height);
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkPlot object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_plot_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_plot_get_type());
}


PHP_FUNCTION(gtk_plot_set_range)
{
	double xmin, xmax, ymin, ymax;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "dddd", &xmin, &xmax, &ymin, &ymax))
		return;

	gtk_plot_set_range(GTK_PLOT(PHP_GTK_GET(this_ptr)), (float)xmin, (float)xmax, (float)ymin, (float)ymax);
	RETURN_NULL();
}

PHP_FUNCTION(gtk_plot_add_data)
{
	zval *data;
	// comment
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &data, gtk_plotdata_ce))
		return;

	gtk_plot_add_data(GTK_PLOT(PHP_GTK_GET(this_ptr)), GTK_PLOT_DATA(PHP_GTK_GET(data)));
	RETURN_NULL();
}

PHP_FUNCTION(gtk_plot_set_xrange)
{
	double xmin, xmax;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "dd", &xmin, &xmax))
		return;

	gtk_plot_set_xrange(GTK_PLOT(PHP_GTK_GET(this_ptr)), (float)xmin, (float)xmax);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_set_yrange)
{
	double ymin, ymax;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "dd", &ymin, &ymax))
		return;

	gtk_plot_set_yrange(GTK_PLOT(PHP_GTK_GET(this_ptr)), (float)ymin, (float)ymax);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_legends_move)
{
	double x, y;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "dd", &x, &y))
		return;

	gtk_plot_legends_move(GTK_PLOT(PHP_GTK_GET(this_ptr)), (float)x, (float)y);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_axis_set_visible)
{
	GtkPlotAxisPos pos;
	zval *php_pos = NULL;
	zend_bool visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Vb", &php_pos, &visible))
		return;

	if (php_pos && !php_gtk_get_simple_enum_value(php_pos, (gint *)&pos)) {
		return;
	}

	gtk_plot_axis_set_visible(GTK_PLOT(PHP_GTK_GET(this_ptr)), pos, (gboolean)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_axis_visible)
{
	GtkPlotAxisPos pos;
	zval *php_pos = NULL;
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "V", &php_pos))
		return;

	if (php_pos && !php_gtk_get_simple_enum_value(php_pos, (gint *)&pos)) {
		return;
	}

	php_retval = gtk_plot_axis_visible(GTK_PLOT(PHP_GTK_GET(this_ptr)), pos);
	RETURN_BOOL(php_retval);
}

PHP_FUNCTION(gtk_plot_axis_set_title)
{
	GtkPlotAxisPos pos;
	zval *php_pos = NULL;
	char *title;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Vs", &php_pos, &title))
		return;

	if (php_pos && !php_gtk_get_simple_enum_value(php_pos, (gint *)&pos)) {
		return;
	}

	gtk_plot_axis_set_title(GTK_PLOT(PHP_GTK_GET(this_ptr)), pos, title);
	RETURN_NULL();
}





/*---------------------- Gtk Sheet Overrides --------------------------*/

PHP_FUNCTION(gtk_plot_axis_show_title)
{
	GtkPlotAxisPos pos;
	zval *php_pos = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "V", &php_pos))
		return;

	if (php_pos && !php_gtk_get_simple_enum_value(php_pos, (gint *)&pos)) {
		return;
	}

	gtk_plot_axis_show_title(GTK_PLOT(PHP_GTK_GET(this_ptr)), pos);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_axis_hide_title)
{
	GtkPlotAxisPos pos;
	zval *php_pos = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "V", &php_pos))
		return;

	if (php_pos && !php_gtk_get_simple_enum_value(php_pos, (gint *)&pos)) {
		return;
	}

	gtk_plot_axis_hide_title(GTK_PLOT(PHP_GTK_GET(this_ptr)), pos);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_axis_move_title)
{
	GtkPlotAxisPos pos;
	zval *php_pos = NULL;
	long angle;
	double x, y;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Vidd", &php_pos, &angle, &x, &y))
		return;

	if (php_pos && !php_gtk_get_simple_enum_value(php_pos, (gint *)&pos)) {
		return;
	}

	gtk_plot_axis_move_title(GTK_PLOT(PHP_GTK_GET(this_ptr)), pos, (gint)angle, (float)x, (float)y);
	RETURN_NULL();
}


static function_entry php_gtk_plot_functions[] = {
	{"GtkPlot",	PHP_FN(gtk_plot_new_with_size),	NULL},
	{"gtkplot",	PHP_FN(gtk_plot_new_with_size),	NULL},
	{"get_type",	PHP_FN(gtk_plot_get_type),	NULL},
	{"set_range",	PHP_FN(gtk_plot_set_range),	NULL},
	{"add_data",	PHP_FN(gtk_plot_add_data),	NULL},
	{"set_xrange",	PHP_FN(gtk_plot_set_xrange),	NULL},
	{"set_yrange",	PHP_FN(gtk_plot_set_yrange),	NULL},
	{"legends_move",	PHP_FN(gtk_plot_legends_move),	NULL},
	{"axis_set_visible",	PHP_FN(gtk_plot_axis_set_visible),	NULL},
	{"axis_visible",	PHP_FN(gtk_plot_axis_visible),	NULL},
	{"axis_set_title",	PHP_FN(gtk_plot_axis_set_title),	NULL},
	{"axis_show_title",	PHP_FN(gtk_plot_axis_show_title),	NULL},
	{"axis_hide_title",	PHP_FN(gtk_plot_axis_hide_title),	NULL},
	{"axis_move_title",	PHP_FN(gtk_plot_axis_move_title),	NULL},
	{NULL, NULL, NULL}
};


/* object GtkPlotCanvas  */

PHP_FUNCTION(gtk_plot_canvas_new)
{
	long width, height;
	double magnification;
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iid", &width, &height, &magnification)) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	wrapped_obj = (GtkObject *)gtk_plot_canvas_new((gint)width, (gint)height, (float)magnification);
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkPlotCanvas object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_plot_canvas_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_plot_canvas_get_type());
}


PHP_FUNCTION(gtk_plot_canvas_set_active_plot)
{
	zval *plot;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &plot, gtk_plot_ce))
		return;

	gtk_plot_canvas_set_active_plot(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)), GTK_PLOT(PHP_GTK_GET(plot)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_add_plot)
{
	zval *plot;
	double x, y;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Odd", &plot, gtk_plot_ce, &x, &y))
		return;

	gtk_plot_canvas_add_plot(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)), GTK_PLOT(PHP_GTK_GET(plot)), (float)x, (float)y);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_paint)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_canvas_paint(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_refresh)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_canvas_refresh(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_construct)
{
	long width, height;
	double magnification;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iid", &width, &height, &magnification))
		return;

	gtk_plot_canvas_construct(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)), (gint)width, (gint)height, (float)magnification);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_freeze)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_canvas_freeze(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_thaw)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_canvas_thaw(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_grid_set_step)
{
	double step;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "d", &step))
		return;

	gtk_plot_canvas_grid_set_step(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)), (float)step);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_cancel_action)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_canvas_cancel_action(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_unselect)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_canvas_unselect(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_set_size)
{
	long width, height;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &width, &height))
		return;

	gtk_plot_canvas_set_size(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)), (gint)width, (gint)height);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_set_magnification)
{
	double magnification;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "d", &magnification))
		return;

	gtk_plot_canvas_set_magnification(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)), (float)magnification);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_canvas_set_background)
{
	zval *background;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &background, gdk_color_ce))
		return;

	gtk_plot_canvas_set_background(GTK_PLOT_CANVAS(PHP_GTK_GET(this_ptr)), PHP_GDK_COLOR_GET(background));
	RETURN_NULL();
}


static function_entry php_gtk_plotcanvas_functions[] = {
	{"GtkPlotCanvas",	PHP_FN(gtk_plot_canvas_new),	NULL},
	{"gtkplotcanvas",	PHP_FN(gtk_plot_canvas_new),	NULL},
	{"get_type",	PHP_FN(gtk_plot_canvas_get_type),	NULL},
	{"set_active_plot",	PHP_FN(gtk_plot_canvas_set_active_plot),	NULL},
	{"add_plot",	PHP_FN(gtk_plot_canvas_add_plot),	NULL},
	{"paint",	PHP_FN(gtk_plot_canvas_paint),	NULL},
	{"refresh",	PHP_FN(gtk_plot_canvas_refresh),	NULL},
	{"construct",	PHP_FN(gtk_plot_canvas_construct),	NULL},
	{"freeze",	PHP_FN(gtk_plot_canvas_freeze),	NULL},
	{"thaw",	PHP_FN(gtk_plot_canvas_thaw),	NULL},
	{"grid_set_step",	PHP_FN(gtk_plot_canvas_grid_set_step),	NULL},
	{"cancel_action",	PHP_FN(gtk_plot_canvas_cancel_action),	NULL},
	{"unselect",	PHP_FN(gtk_plot_canvas_unselect),	NULL},
	{"set_size",	PHP_FN(gtk_plot_canvas_set_size),	NULL},
	{"set_magnification",	PHP_FN(gtk_plot_canvas_set_magnification),	NULL},
	{"set_background",	PHP_FN(gtk_plot_canvas_set_background),	NULL},
	{NULL, NULL, NULL}
};


/* object GtkPlotData  */

PHP_FUNCTION(gtk_plot_data_new)
{
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "")) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	wrapped_obj = (GtkObject *)gtk_plot_data_new();
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkPlotData object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_plot_data_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_plot_data_get_type());
}


PHP_FUNCTION(gtk_plot_data_paint)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_paint(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_update)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_update(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_draw_points)
{
	long n;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &n))
		return;

	gtk_plot_data_draw_points(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (gint)n);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_draw_symbol)
{
	double x, y;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "dd", &x, &y))
		return;

	gtk_plot_data_draw_symbol(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (float)x, (float)y);
	RETURN_NULL();
}

PHP_FUNCTION(gtk_plot_data_set_points)
{
	gdouble *x;
	gdouble *y;
	gdouble *dx;
	gdouble *dy;
	zval ** temp;
	zval *php_x = NULL;
	zval *php_y = NULL;
	zval *php_dx = NULL;
	zval *php_dy = NULL;
	gint j;
	HashTable *hash;
	gint n_elems;

	NOT_STATIC_METHOD();
	if( !php_gtk_parse_args(ZEND_NUM_ARGS(),"a/a/a/a/i", &php_x,&php_y,&php_dx,&php_dy,&n_elems ))
		return;
//	n_elems = zend_hash_num_elements( hash );
//	n_elems = num_points;

	hash = HASH_OF(php_x);
	x =  emalloc( n_elems * sizeof( gdouble )); j = 0;
	zend_hash_internal_pointer_reset( hash );
	while( j < n_elems && zend_hash_get_current_data( hash, (void **)&temp) == SUCCESS )
	{
		x[j++] = (gdouble) Z_DVAL_PP( temp );
		zend_hash_move_forward(hash);
	}		
	hash = HASH_OF(php_y);
	y =  emalloc( n_elems * sizeof( gdouble )); j = 0;
	zend_hash_internal_pointer_reset( hash );
	while( j < n_elems && zend_hash_get_current_data( hash, (void **)&temp) == SUCCESS )
	{
		y[j++] = (gdouble) Z_DVAL_PP( temp );
		zend_hash_move_forward(hash);
	}		
	hash = HASH_OF(php_dx);
	dx = emalloc( n_elems * sizeof( gdouble )); j = 0;
	zend_hash_internal_pointer_reset( hash );
	while( j < n_elems && zend_hash_get_current_data( hash, (void **)&temp) == SUCCESS )
	{
		dx[j++] = (gdouble) Z_DVAL_PP( temp );
		zend_hash_move_forward(hash);
	}		
	hash = HASH_OF(php_dy);
	dy = emalloc( n_elems * sizeof( gdouble )); j = 0;
	zend_hash_internal_pointer_reset( hash );
	while( j < n_elems && zend_hash_get_current_data( hash, (void **)&temp) == SUCCESS )
	{
		dy[j++] = (gdouble) Z_DVAL_PP( temp );
		zend_hash_move_forward(hash);
	}		

	gtk_plot_data_set_points( GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)),x, y, dx, dy, n_elems);
	/*
	efree( x );
	efree( y );
	efree( dx );
	efree( dy );
	*/
	RETURN_NULL();
}

PHP_FUNCTION(gtk_plot_data_set_legend)
{
	char *name;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &name))
		return;

	gtk_plot_data_set_legend(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), name);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_a_scale)
{
	double a_scale;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "d", &a_scale))
		return;

	gtk_plot_data_set_a_scale(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (float)a_scale);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_get_a_scale)
{
	double php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_plot_data_get_a_scale(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_DOUBLE(php_retval);
}


PHP_FUNCTION(gtk_plot_data_show_labels)
{
	zend_bool show_labels;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &show_labels))
		return;

	gtk_plot_data_show_labels(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (gboolean)show_labels);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_labels_set_attributes)
{
	char *font;
	long height, angle;
	zval *foreground, *background;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "siiOO", &font, &height, &angle, &foreground, gdk_color_ce, &background, gdk_color_ce))
		return;

	gtk_plot_data_labels_set_attributes(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), font, (gint)height, (gint)angle, PHP_GDK_COLOR_GET(foreground), PHP_GDK_COLOR_GET(background));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_numpoints)
{
	long num_points;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &num_points))
		return;

	gtk_plot_data_set_numpoints(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (gint)num_points);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_get_numpoints)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_plot_data_get_numpoints(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_plot_data_set_symbol)
{
	GtkPlotSymbolType type;
	zval *php_type = NULL, *php_style = NULL, *color, *border_color;
	GtkPlotSymbolStyle style;
	long size;
	double line_width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VVidOO", &php_type, &php_style, &size, &line_width, &color, gdk_color_ce, &border_color, gdk_color_ce))
		return;

	if (php_type && !php_gtk_get_simple_enum_value(php_type, (gint *)&type)) {
		return;
	}

	if (php_style && !php_gtk_get_simple_enum_value(php_style, (gint *)&style)) {
		return;
	}

	gtk_plot_data_set_symbol(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), type, style, (gint)size, (float)line_width, PHP_GDK_COLOR_GET(color), PHP_GDK_COLOR_GET(border_color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_connector)
{
	GtkPlotConnector connector;
	zval *php_connector = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "V", &php_connector))
		return;

	if (php_connector && !php_gtk_get_simple_enum_value(php_connector, (gint *)&connector)) {
		return;
	}

	gtk_plot_data_set_connector(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), connector);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_get_connector)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_plot_data_get_connector(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_plot_data_set_line_attributes)
{
	GtkPlotLineStyle style;
	zval *php_style = NULL, *color;
	double width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VdO", &php_style, &width, &color, gdk_color_ce))
		return;

	if (php_style && !php_gtk_get_simple_enum_value(php_style, (gint *)&style)) {
		return;
	}

	gtk_plot_data_set_line_attributes(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), style, (float)width, PHP_GDK_COLOR_GET(color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_x_attributes)
{
	GtkPlotLineStyle style;
	zval *php_style = NULL, *color;
	double width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VdO", &php_style, &width, &color, gdk_color_ce))
		return;

	if (php_style && !php_gtk_get_simple_enum_value(php_style, (gint *)&style)) {
		return;
	}

	gtk_plot_data_set_x_attributes(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), style, (float)width, PHP_GDK_COLOR_GET(color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_y_attributes)
{
	GtkPlotLineStyle style;
	zval *php_style = NULL, *color;
	double width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VdO", &php_style, &width, &color, gdk_color_ce))
		return;

	if (php_style && !php_gtk_get_simple_enum_value(php_style, (gint *)&style)) {
		return;
	}

	gtk_plot_data_set_y_attributes(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), style, (float)width, PHP_GDK_COLOR_GET(color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_z_attributes)
{
	GtkPlotLineStyle style;
	zval *php_style = NULL, *color;
	double width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VdO", &php_style, &width, &color, gdk_color_ce))
		return;

	if (php_style && !php_gtk_get_simple_enum_value(php_style, (gint *)&style)) {
		return;
	}

	gtk_plot_data_set_z_attributes(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), style, (float)width, PHP_GDK_COLOR_GET(color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_show_xerrbars)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_show_xerrbars(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_show_yerrbars)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_show_yerrbars(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_show_zerrbars)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_show_zerrbars(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_hide_xerrbars)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_hide_xerrbars(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_hide_yerrbars)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_hide_yerrbars(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_hide_zerrbars)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_hide_zerrbars(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_fill_area)
{
	zend_bool fill;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &fill))
		return;

	gtk_plot_data_fill_area(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (gboolean)fill);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_area_is_filled)
{
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_plot_data_area_is_filled(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_BOOL(php_retval);
}


PHP_FUNCTION(gtk_plot_data_show_legend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_show_legend(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_hide_legend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_hide_legend(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_legend_precision)
{
	long precision;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &precision))
		return;

	gtk_plot_data_set_legend_precision(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (gint)precision);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_get_legend_precision)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_plot_data_get_legend_precision(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_plot_data_set_name)
{
	char *name;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &name))
		return;

	gtk_plot_data_set_name(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), name);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_gradient_mask)
{
	long mask;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &mask))
		return;

	gtk_plot_data_set_gradient_mask(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (gint)mask);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_get_gradient_mask)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_plot_data_get_gradient_mask(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_plot_data_gradient_set_visible)
{
	zend_bool visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &visible))
		return;

	gtk_plot_data_gradient_set_visible(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (gboolean)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_gradient_visible)
{
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_plot_data_gradient_visible(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_BOOL(php_retval);
}


PHP_FUNCTION(gtk_plot_data_draw_gradient)
{
	long x, y;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &x, &y))
		return;

	gtk_plot_data_draw_gradient(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (gint)x, (gint)y);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_gradient_autoscale_a)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_gradient_autoscale_a(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_gradient_autoscale_da)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_gradient_autoscale_da(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_gradient_autoscale_z)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_gradient_autoscale_z(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_gradient_colors)
{
	zval *min, *max;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OO", &min, gdk_color_ce, &max, gdk_color_ce))
		return;

	gtk_plot_data_set_gradient_colors(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), PHP_GDK_COLOR_GET(min), PHP_GDK_COLOR_GET(max));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_get_gradient_colors)
{
	zval *min, *max;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OO", &min, gdk_color_ce, &max, gdk_color_ce))
		return;

	gtk_plot_data_get_gradient_colors(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), PHP_GDK_COLOR_GET(min), PHP_GDK_COLOR_GET(max));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_set_gradient)
{
	double min, max;
	long nlevels, nsublevels;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ddii", &min, &max, &nlevels, &nsublevels))
		return;

	gtk_plot_data_set_gradient(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (float)min, (float)max, (gint)nlevels, (gint)nsublevels);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_get_gradient_level)
{
	double level;
	zval *color;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "dO", &level, &color, gdk_color_ce))
		return;

	gtk_plot_data_get_gradient_level(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (float)level, PHP_GDK_COLOR_GET(color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_remove_link)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_remove_link(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_remove_markers)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_plot_data_remove_markers(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_show_markers)
{
	zend_bool show;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &show))
		return;

	gtk_plot_data_show_markers(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)), (gboolean)show);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_plot_data_markers_visible)
{
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_plot_data_markers_visible(GTK_PLOT_DATA(PHP_GTK_GET(this_ptr)));
	RETURN_BOOL(php_retval);
}


static function_entry php_gtk_plotdata_functions[] = {
	{"GtkPlotData",	PHP_FN(gtk_plot_data_new),	NULL},
	{"gtkplotdata",	PHP_FN(gtk_plot_data_new),	NULL},
	{"get_type",	PHP_FN(gtk_plot_data_get_type),	NULL},
	{"paint",	PHP_FN(gtk_plot_data_paint),	NULL},
	{"update",	PHP_FN(gtk_plot_data_update),	NULL},
	{"draw_points",	PHP_FN(gtk_plot_data_draw_points),	NULL},
	{"draw_symbol",	PHP_FN(gtk_plot_data_draw_symbol),	NULL},
	{"set_points",	PHP_FN(gtk_plot_data_set_points),	NULL},
	{"set_legend",	PHP_FN(gtk_plot_data_set_legend),	NULL},
	{"set_a_scale",	PHP_FN(gtk_plot_data_set_a_scale),	NULL},
	{"get_a_scale",	PHP_FN(gtk_plot_data_get_a_scale),	NULL},
	{"show_labels",	PHP_FN(gtk_plot_data_show_labels),	NULL},
	{"labels_set_attributes",	PHP_FN(gtk_plot_data_labels_set_attributes),	NULL},
	{"set_numpoints",	PHP_FN(gtk_plot_data_set_numpoints),	NULL},
	{"get_numpoints",	PHP_FN(gtk_plot_data_get_numpoints),	NULL},
	{"set_symbol",	PHP_FN(gtk_plot_data_set_symbol),	NULL},
	{"set_connector",	PHP_FN(gtk_plot_data_set_connector),	NULL},
	{"get_connector",	PHP_FN(gtk_plot_data_get_connector),	NULL},
	{"set_line_attributes",	PHP_FN(gtk_plot_data_set_line_attributes),	NULL},
	{"set_x_attributes",	PHP_FN(gtk_plot_data_set_x_attributes),	NULL},
	{"set_y_attributes",	PHP_FN(gtk_plot_data_set_y_attributes),	NULL},
	{"set_z_attributes",	PHP_FN(gtk_plot_data_set_z_attributes),	NULL},
	{"show_xerrbars",	PHP_FN(gtk_plot_data_show_xerrbars),	NULL},
	{"show_yerrbars",	PHP_FN(gtk_plot_data_show_yerrbars),	NULL},
	{"show_zerrbars",	PHP_FN(gtk_plot_data_show_zerrbars),	NULL},
	{"hide_xerrbars",	PHP_FN(gtk_plot_data_hide_xerrbars),	NULL},
	{"hide_yerrbars",	PHP_FN(gtk_plot_data_hide_yerrbars),	NULL},
	{"hide_zerrbars",	PHP_FN(gtk_plot_data_hide_zerrbars),	NULL},
	{"fill_area",	PHP_FN(gtk_plot_data_fill_area),	NULL},
	{"area_is_filled",	PHP_FN(gtk_plot_data_area_is_filled),	NULL},
	{"show_legend",	PHP_FN(gtk_plot_data_show_legend),	NULL},
	{"hide_legend",	PHP_FN(gtk_plot_data_hide_legend),	NULL},
	{"set_legend_precision",	PHP_FN(gtk_plot_data_set_legend_precision),	NULL},
	{"get_legend_precision",	PHP_FN(gtk_plot_data_get_legend_precision),	NULL},
	{"set_name",	PHP_FN(gtk_plot_data_set_name),	NULL},
	{"set_gradient_mask",	PHP_FN(gtk_plot_data_set_gradient_mask),	NULL},
	{"get_gradient_mask",	PHP_FN(gtk_plot_data_get_gradient_mask),	NULL},
	{"gradient_set_visible",	PHP_FN(gtk_plot_data_gradient_set_visible),	NULL},
	{"gradient_visible",	PHP_FN(gtk_plot_data_gradient_visible),	NULL},
	{"draw_gradient",	PHP_FN(gtk_plot_data_draw_gradient),	NULL},
	{"gradient_autoscale_a",	PHP_FN(gtk_plot_data_gradient_autoscale_a),	NULL},
	{"gradient_autoscale_da",	PHP_FN(gtk_plot_data_gradient_autoscale_da),	NULL},
	{"gradient_autoscale_z",	PHP_FN(gtk_plot_data_gradient_autoscale_z),	NULL},
	{"set_gradient_colors",	PHP_FN(gtk_plot_data_set_gradient_colors),	NULL},
	{"get_gradient_colors",	PHP_FN(gtk_plot_data_get_gradient_colors),	NULL},
	{"set_gradient",	PHP_FN(gtk_plot_data_set_gradient),	NULL},
	{"get_gradient_level",	PHP_FN(gtk_plot_data_get_gradient_level),	NULL},
	{"remove_link",	PHP_FN(gtk_plot_data_remove_link),	NULL},
	{"remove_markers",	PHP_FN(gtk_plot_data_remove_markers),	NULL},
	{"show_markers",	PHP_FN(gtk_plot_data_show_markers),	NULL},
	{"markers_visible",	PHP_FN(gtk_plot_data_markers_visible),	NULL},
	{NULL, NULL, NULL}
};


/* object GtkPlotAxis  */

PHP_FUNCTION(gtk_plot_axis_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_plot_axis_get_type());
}


static function_entry php_gtk_plotaxis_functions[] = {
	{"GtkPlotAxis",	PHP_FN(no_constructor),	NULL},
	{"gtkplotaxis",	PHP_FN(no_constructor),	NULL},
	{"get_type",	PHP_FN(gtk_plot_axis_get_type),	NULL},
	{NULL, NULL, NULL}
};


/* object GtkSheet  */

PHP_FUNCTION(gtk_sheet_new)
{
	long rows, columns;
	char *title;
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iis", &rows, &columns, &title)) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	wrapped_obj = (GtkObject *)gtk_sheet_new((guint)rows, (guint)columns, title);
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkSheet object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_sheet_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_sheet_get_type());
}


PHP_FUNCTION(gtk_sheet_construct)
{
	long rows, columns;
	char *title;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iis", &rows, &columns, &title))
		return;

	gtk_sheet_construct(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)rows, (guint)columns, title);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_construct_browser)
{
	long rows, columns;
	char *title;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iis", &rows, &columns, &title))
		return;

	gtk_sheet_construct_browser(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)rows, (guint)columns, title);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_construct_with_custom_entry)
{
	long rows, columns, entry_type;
	char *title;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iisi", &rows, &columns, &title, &entry_type))
		return;

	gtk_sheet_construct_with_custom_entry(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)rows, (guint)columns, title, (GtkType)entry_type);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_hadjustment)
{
	zval *adjustment;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &adjustment, gtk_adjustment_ce))
		return;

	gtk_sheet_set_hadjustment(GTK_SHEET(PHP_GTK_GET(this_ptr)), GTK_ADJUSTMENT(PHP_GTK_GET(adjustment)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_vadjustment)
{
	zval *adjustment;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &adjustment, gtk_adjustment_ce))
		return;

	gtk_sheet_set_vadjustment(GTK_SHEET(PHP_GTK_GET(this_ptr)), GTK_ADJUSTMENT(PHP_GTK_GET(adjustment)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_change_entry)
{
	long entry_type;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &entry_type))
		return;

	gtk_sheet_change_entry(GTK_SHEET(PHP_GTK_GET(this_ptr)), (GtkType)entry_type);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_get_entry)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gtk_new((GtkObject *)gtk_sheet_get_entry(GTK_SHEET(PHP_GTK_GET(this_ptr)))));
	return;
}


PHP_FUNCTION(gtk_sheet_get_entry_widget)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gtk_new((GtkObject *)gtk_sheet_get_entry_widget(GTK_SHEET(PHP_GTK_GET(this_ptr)))));
	return;
}


PHP_FUNCTION(gtk_sheet_get_state)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_sheet_get_state(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_sheet_get_columns_count)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_sheet_get_columns_count(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_sheet_get_rows_count)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_sheet_get_rows_count(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_sheet_get_visible_range)
{
	GtkSheetRange range;
	zval *php_range;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &php_range, gtk_sheet_range_ce))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_get_visible_range(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_selection_mode)
{
	long mode;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &mode))
		return;

	gtk_sheet_set_selection_mode(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)mode);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_title)
{
	char *title;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &title))
		return;

	gtk_sheet_set_title(GTK_SHEET(PHP_GTK_GET(this_ptr)), title);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_freeze)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_sheet_freeze(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_thaw)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_sheet_thaw(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_background)
{
	zval *bg_color;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &bg_color, gdk_color_ce))
		return;

	gtk_sheet_set_background(GTK_SHEET(PHP_GTK_GET(this_ptr)), PHP_GDK_COLOR_GET(bg_color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_grid)
{
	zval *grid_color;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &grid_color, gdk_color_ce))
		return;

	gtk_sheet_set_grid(GTK_SHEET(PHP_GTK_GET(this_ptr)), PHP_GDK_COLOR_GET(grid_color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_show_grid)
{
	zend_bool show;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &show))
		return;

	gtk_sheet_show_grid(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gboolean)show);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_grid_visible)
{
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_sheet_grid_visible(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_BOOL(php_retval);
}


PHP_FUNCTION(gtk_sheet_set_column_title)
{
	long column;
	char *title;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &column, &title))
		return;

	gtk_sheet_set_column_title(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)column, title);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_row_title)
{
	long row;
	char *title;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &row, &title))
		return;

	gtk_sheet_set_row_title(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, title);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_row_button_add_label)
{
	long row;
	char *label;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &row, &label))
		return;

	gtk_sheet_row_button_add_label(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, label);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_column_button_add_label)
{
	long column;
	char *label;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &column, &label))
		return;

	gtk_sheet_column_button_add_label(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)column, label);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_row_button_justify)
{
	long row;
	GtkJustification justification;
	zval *php_justification = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iV", &row, &php_justification))
		return;

	if (php_justification && !php_gtk_get_enum_value(GTK_TYPE_JUSTIFICATION, php_justification, (gint *)&justification)) {
		return;
	}

	gtk_sheet_row_button_justify(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, justification);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_column_button_justify)
{
	long column;
	GtkJustification justification;
	zval *php_justification = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iV", &column, &php_justification))
		return;

	if (php_justification && !php_gtk_get_enum_value(GTK_TYPE_JUSTIFICATION, php_justification, (gint *)&justification)) {
		return;
	}

	gtk_sheet_column_button_justify(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)column, justification);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_moveto)
{
	long row, column;
	double row_align, col_align;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iidd", &row, &column, &row_align, &col_align))
		return;

	gtk_sheet_moveto(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gint)column, (float)row_align, (float)col_align);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_row_titles_width)
{
	long width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &width))
		return;

	gtk_sheet_set_row_titles_width(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)width);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_column_titles_height)
{
	long height;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &height))
		return;

	gtk_sheet_set_column_titles_height(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)height);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_show_column_titles)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_sheet_show_column_titles(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_show_row_titles)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_sheet_show_row_titles(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_hide_column_titles)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_sheet_hide_column_titles(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_hide_row_titles)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_sheet_hide_row_titles(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_column_set_sensitivity)
{
	long column;
	zend_bool sensitive;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ib", &column, &sensitive))
		return;

	gtk_sheet_column_set_sensitivity(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)column, (gboolean)sensitive);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_columns_set_sensitivity)
{
	zend_bool sensitive;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &sensitive))
		return;

	gtk_sheet_columns_set_sensitivity(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gboolean)sensitive);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_row_set_sensitivity)
{
	long row;
	zend_bool sensitive;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ib", &row, &sensitive))
		return;

	gtk_sheet_row_set_sensitivity(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gboolean)sensitive);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_rows_set_sensitivity)
{
	zend_bool sensitive;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &sensitive))
		return;

	gtk_sheet_rows_set_sensitivity(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gboolean)sensitive);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_column_set_visibility)
{
	long column;
	zend_bool visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ib", &column, &visible))
		return;

	gtk_sheet_column_set_visibility(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)column, (gboolean)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_column_label_set_visibility)
{
	long column;
	zend_bool visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ib", &column, &visible))
		return;

	gtk_sheet_column_label_set_visibility(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)column, (gboolean)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_columns_labels_set_visibility)
{
	zend_bool visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &visible))
		return;

	gtk_sheet_columns_labels_set_visibility(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gboolean)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_row_set_visibility)
{
	long row;
	zend_bool visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ib", &row, &visible))
		return;

	gtk_sheet_row_set_visibility(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gboolean)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_row_label_set_visibility)
{
	long row;
	zend_bool visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ib", &row, &visible))
		return;

	gtk_sheet_row_label_set_visibility(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gboolean)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_rows_labels_set_visibility)
{
	zend_bool visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &visible))
		return;

	gtk_sheet_rows_labels_set_visibility(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gboolean)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_select_row)
{
	long row;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &row))
		return;

	gtk_sheet_select_row(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_select_column)
{
	long column;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &column))
		return;

	gtk_sheet_select_column(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)column);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_clip_range)
{
	GtkSheetRange range;
	zval *php_range;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &php_range, gtk_sheet_range_ce))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_clip_range(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_unclip_range)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_sheet_unclip_range(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_select_range)
{
	GtkSheetRange range;
	zval *php_range;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &php_range, gtk_sheet_range_ce))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_select_range(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_unselect_range)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_sheet_unselect_range(GTK_SHEET(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_active_cell)
{
	long row, column;
	gboolean php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &row, &column))
		return;

	php_retval = gtk_sheet_set_active_cell(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gint)column);
	RETURN_BOOL(php_retval);
}


PHP_FUNCTION(gtk_sheet_get_active_cell)
{
	gint  row, column;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;
 
 

	gtk_sheet_get_active_cell(GTK_SHEET(PHP_GTK_GET(this_ptr)), &row, &column);

	array_init(return_value);
	add_next_index_double(return_value, (long)row);
	add_next_index_double(return_value, (long)column);

}

PHP_FUNCTION(gtk_sheet_set_cell)
{
	long row, col;
	GtkJustification justification;
	zval *php_justification = NULL;
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iiVs", &row, &col, &php_justification, &text))
		return;

	if (php_justification && !php_gtk_get_enum_value(GTK_TYPE_JUSTIFICATION, php_justification, (gint *)&justification)) {
		return;
	}

	gtk_sheet_set_cell(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gint)col, justification, text);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_cell_text)
{
	long row, col;
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iis", &row, &col, &text))
		return;

	gtk_sheet_set_cell_text(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gint)col, text);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_cell_get_text)
{
	long row, col;
	gchar *ret;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &row, &col))
		return;

	ret = gtk_sheet_cell_get_text(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gint)col);
	if (ret) {
		RETURN_STRING(ret, 1);
		g_free(ret);
	} else
		RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_cell_clear)
{
	long row, col;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &row, &col))
		return;

	gtk_sheet_cell_clear(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gint)col);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_cell_delete)
{
	long row, col;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &row, &col))
		return;

	gtk_sheet_cell_delete(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gint)col);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_clear)
{
	GtkSheetRange range;
	zval *php_range;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &php_range, gtk_sheet_range_ce))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_range_clear(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_delete)
{
	GtkSheetRange range;
	zval *php_range;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &php_range, gtk_sheet_range_ce))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_range_delete(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_cell_get_state)
{
	long row, col, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &row, &col))
		return;

	php_retval = gtk_sheet_cell_get_state(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gint)col);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_sheet_remove_link)
{
	long row, col;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &row, &col))
		return;

	gtk_sheet_remove_link(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (gint)col);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_column_width)
{
	long column, width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &column, &width))
		return;

	gtk_sheet_set_column_width(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)column, (guint)width);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_set_row_height)
{
	long row, height;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &row, &height))
		return;

	gtk_sheet_set_row_height(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)row, (guint)height);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_add_column)
{
	long ncols;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &ncols))
		return;

	gtk_sheet_add_column(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)ncols);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_add_row)
{
	long nrows;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &nrows))
		return;

	gtk_sheet_add_row(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)nrows);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_insert_rows)
{
	long row, nrows;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &row, &nrows))
		return;

	gtk_sheet_insert_rows(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)row, (guint)nrows);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_insert_columns)
{
	long col, ncols;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &col, &ncols))
		return;

	gtk_sheet_insert_columns(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)col, (guint)ncols);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_delete_rows)
{
	long row, nrows;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &row, &nrows))
		return;

	gtk_sheet_delete_rows(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)row, (guint)nrows);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_delete_columns)
{
	long col, ncols;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &col, &ncols))
		return;

	gtk_sheet_delete_columns(GTK_SHEET(PHP_GTK_GET(this_ptr)), (guint)col, (guint)ncols);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_set_background)
{
	GtkSheetRange range;
	zval *php_range, *color;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OO", &php_range, gtk_sheet_range_ce, &color, gdk_color_ce))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_range_set_background(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range, PHP_GDK_COLOR_GET(color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_set_foreground)
{
	GtkSheetRange range;
	zval *php_range, *color;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OO", &php_range, gtk_sheet_range_ce, &color, gdk_color_ce))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_range_set_foreground(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range, PHP_GDK_COLOR_GET(color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_set_justification)
{
	GtkSheetRange range;
	zval *php_range, *php_justification = NULL;
	GtkJustification justification;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OV", &php_range, gtk_sheet_range_ce, &php_justification))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	if (php_justification && !php_gtk_get_enum_value(GTK_TYPE_JUSTIFICATION, php_justification, (gint *)&justification)) {
		return;
	}

	gtk_sheet_range_set_justification(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range, justification);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_column_set_justification)
{
	long column;
	GtkJustification justification;
	zval *php_justification = NULL;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iV", &column, &php_justification))
		return;

	if (php_justification && !php_gtk_get_enum_value(GTK_TYPE_JUSTIFICATION, php_justification, (gint *)&justification)) {
		return;
	}

	gtk_sheet_column_set_justification(GTK_SHEET(PHP_GTK_GET(this_ptr)), (gint)column, justification);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_set_editable)
{
	GtkSheetRange range;
	zval *php_range;
	long editable;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Oi", &php_range, gtk_sheet_range_ce, &editable))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_range_set_editable(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range, (gint)editable);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_set_visible)
{
	GtkSheetRange range;
	zval *php_range;
	zend_bool visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Ob", &php_range, gtk_sheet_range_ce, &visible))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_range_set_visible(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range, (gboolean)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_set_border)
{
	GtkSheetRange range;
	zval *php_range;
	long mask, width, line_style;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Oiii", &php_range, gtk_sheet_range_ce, &mask, &width, &line_style))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_range_set_border(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range, (gint)mask, (guint)width, (gint)line_style);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_set_border_color)
{
	GtkSheetRange range;
	zval *php_range, *color;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OO", &php_range, gtk_sheet_range_ce, &color, gdk_color_ce))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_range_set_border_color(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range, PHP_GDK_COLOR_GET(color));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_range_set_font)
{
	GtkSheetRange range;
	zval *php_range, *font;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OO", &php_range, gtk_sheet_range_ce, &font, gdk_font_ce))
		return;

	if (!php_gtk_sheet_range_get(php_range, &range)) {
		return;
	}

	gtk_sheet_range_set_font(GTK_SHEET(PHP_GTK_GET(this_ptr)), &range, PHP_GDK_FONT_GET(font));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_attach)
{
	zval *widget;
	long row, col;
	double x_align, y_align;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Oiidd", &widget, gtk_widget_ce, &row, &col, &x_align, &y_align))
		return;

	gtk_sheet_attach(GTK_SHEET(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(widget)), (gint)row, (gint)col, (float)x_align, (float)y_align);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_move_child)
{
	zval *widget;
	long x, y;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Oii", &widget, gtk_widget_ce, &x, &y))
		return;

	gtk_sheet_move_child(GTK_SHEET(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(widget)), (gint)x, (gint)y);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_sheet_button_attach)
{
	zval *widget;
	long row, col;
	double x_align, y_align;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Oiidd", &widget, gtk_widget_ce, &row, &col, &x_align, &y_align))
		return;

	gtk_sheet_button_attach(GTK_SHEET(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(widget)), (gint)row, (gint)col, (float)x_align, (float)y_align);
	RETURN_NULL();
}


static function_entry php_gtk_sheet_functions[] = {
	{"GtkSheet",	PHP_FN(gtk_sheet_new),	NULL},
	{"gtksheet",	PHP_FN(gtk_sheet_new),	NULL},
	{"get_type",	PHP_FN(gtk_sheet_get_type),	NULL},
	{"construct",	PHP_FN(gtk_sheet_construct),	NULL},
	{"construct_browser",	PHP_FN(gtk_sheet_construct_browser),	NULL},
	{"construct_with_custom_entry",	PHP_FN(gtk_sheet_construct_with_custom_entry),	NULL},
	{"set_hadjustment",	PHP_FN(gtk_sheet_set_hadjustment),	NULL},
	{"set_vadjustment",	PHP_FN(gtk_sheet_set_vadjustment),	NULL},
	{"change_entry",	PHP_FN(gtk_sheet_change_entry),	NULL},
	{"get_entry",	PHP_FN(gtk_sheet_get_entry),	NULL},
	{"get_entry_widget",	PHP_FN(gtk_sheet_get_entry_widget),	NULL},
	{"get_state",	PHP_FN(gtk_sheet_get_state),	NULL},
	{"get_columns_count",	PHP_FN(gtk_sheet_get_columns_count),	NULL},
	{"get_rows_count",	PHP_FN(gtk_sheet_get_rows_count),	NULL},
	{"get_visible_range",	PHP_FN(gtk_sheet_get_visible_range),	NULL},
	{"set_selection_mode",	PHP_FN(gtk_sheet_set_selection_mode),	NULL},
	{"set_title",	PHP_FN(gtk_sheet_set_title),	NULL},
	{"freeze",	PHP_FN(gtk_sheet_freeze),	NULL},
	{"thaw",	PHP_FN(gtk_sheet_thaw),	NULL},
	{"set_background",	PHP_FN(gtk_sheet_set_background),	NULL},
	{"set_grid",	PHP_FN(gtk_sheet_set_grid),	NULL},
	{"show_grid",	PHP_FN(gtk_sheet_show_grid),	NULL},
	{"grid_visible",	PHP_FN(gtk_sheet_grid_visible),	NULL},
	{"set_column_title",	PHP_FN(gtk_sheet_set_column_title),	NULL},
	{"set_row_title",	PHP_FN(gtk_sheet_set_row_title),	NULL},
	{"row_button_add_label",	PHP_FN(gtk_sheet_row_button_add_label),	NULL},
	{"column_button_add_label",	PHP_FN(gtk_sheet_column_button_add_label),	NULL},
	{"row_button_justify",	PHP_FN(gtk_sheet_row_button_justify),	NULL},
	{"column_button_justify",	PHP_FN(gtk_sheet_column_button_justify),	NULL},
	{"moveto",	PHP_FN(gtk_sheet_moveto),	NULL},
	{"set_row_titles_width",	PHP_FN(gtk_sheet_set_row_titles_width),	NULL},
	{"set_column_titles_height",	PHP_FN(gtk_sheet_set_column_titles_height),	NULL},
	{"show_column_titles",	PHP_FN(gtk_sheet_show_column_titles),	NULL},
	{"show_row_titles",	PHP_FN(gtk_sheet_show_row_titles),	NULL},
	{"hide_column_titles",	PHP_FN(gtk_sheet_hide_column_titles),	NULL},
	{"hide_row_titles",	PHP_FN(gtk_sheet_hide_row_titles),	NULL},
	{"column_set_sensitivity",	PHP_FN(gtk_sheet_column_set_sensitivity),	NULL},
	{"columns_set_sensitivity",	PHP_FN(gtk_sheet_columns_set_sensitivity),	NULL},
	{"row_set_sensitivity",	PHP_FN(gtk_sheet_row_set_sensitivity),	NULL},
	{"rows_set_sensitivity",	PHP_FN(gtk_sheet_rows_set_sensitivity),	NULL},
	{"column_set_visibility",	PHP_FN(gtk_sheet_column_set_visibility),	NULL},
	{"column_label_set_visibility",	PHP_FN(gtk_sheet_column_label_set_visibility),	NULL},
	{"columns_labels_set_visibility",	PHP_FN(gtk_sheet_columns_labels_set_visibility),	NULL},
	{"row_set_visibility",	PHP_FN(gtk_sheet_row_set_visibility),	NULL},
	{"row_label_set_visibility",	PHP_FN(gtk_sheet_row_label_set_visibility),	NULL},
	{"rows_labels_set_visibility",	PHP_FN(gtk_sheet_rows_labels_set_visibility),	NULL},
	{"select_row",	PHP_FN(gtk_sheet_select_row),	NULL},
	{"select_column",	PHP_FN(gtk_sheet_select_column),	NULL},
	{"clip_range",	PHP_FN(gtk_sheet_clip_range),	NULL},
	{"unclip_range",	PHP_FN(gtk_sheet_unclip_range),	NULL},
	{"select_range",	PHP_FN(gtk_sheet_select_range),	NULL},
	{"unselect_range",	PHP_FN(gtk_sheet_unselect_range),	NULL},
	{"set_active_cell",	PHP_FN(gtk_sheet_set_active_cell),	NULL},
	{"get_active_cell",	PHP_FN(gtk_sheet_get_active_cell),	NULL},
	{"set_cell",	PHP_FN(gtk_sheet_set_cell),	NULL},
	{"set_cell_text",	PHP_FN(gtk_sheet_set_cell_text),	NULL},
	{"cell_get_text",	PHP_FN(gtk_sheet_cell_get_text),	NULL},
	{"cell_clear",	PHP_FN(gtk_sheet_cell_clear),	NULL},
	{"cell_delete",	PHP_FN(gtk_sheet_cell_delete),	NULL},
	{"range_clear",	PHP_FN(gtk_sheet_range_clear),	NULL},
	{"range_delete",	PHP_FN(gtk_sheet_range_delete),	NULL},
	{"cell_get_state",	PHP_FN(gtk_sheet_cell_get_state),	NULL},
	{"remove_link",	PHP_FN(gtk_sheet_remove_link),	NULL},
	{"set_column_width",	PHP_FN(gtk_sheet_set_column_width),	NULL},
	{"set_row_height",	PHP_FN(gtk_sheet_set_row_height),	NULL},
	{"add_column",	PHP_FN(gtk_sheet_add_column),	NULL},
	{"add_row",	PHP_FN(gtk_sheet_add_row),	NULL},
	{"insert_rows",	PHP_FN(gtk_sheet_insert_rows),	NULL},
	{"insert_columns",	PHP_FN(gtk_sheet_insert_columns),	NULL},
	{"delete_rows",	PHP_FN(gtk_sheet_delete_rows),	NULL},
	{"delete_columns",	PHP_FN(gtk_sheet_delete_columns),	NULL},
	{"range_set_background",	PHP_FN(gtk_sheet_range_set_background),	NULL},
	{"range_set_foreground",	PHP_FN(gtk_sheet_range_set_foreground),	NULL},
	{"range_set_justification",	PHP_FN(gtk_sheet_range_set_justification),	NULL},
	{"column_set_justification",	PHP_FN(gtk_sheet_column_set_justification),	NULL},
	{"range_set_editable",	PHP_FN(gtk_sheet_range_set_editable),	NULL},
	{"range_set_visible",	PHP_FN(gtk_sheet_range_set_visible),	NULL},
	{"range_set_border",	PHP_FN(gtk_sheet_range_set_border),	NULL},
	{"range_set_border_color",	PHP_FN(gtk_sheet_range_set_border_color),	NULL},
	{"range_set_font",	PHP_FN(gtk_sheet_range_set_font),	NULL},
	{"attach",	PHP_FN(gtk_sheet_attach),	NULL},
	{"move_child",	PHP_FN(gtk_sheet_move_child),	NULL},
	{"button_attach",	PHP_FN(gtk_sheet_button_attach),	NULL},
	{NULL, NULL, NULL}
};


void php_extra_register_classes(void)
{
	zend_class_entry ce;
	TSRMLS_FETCH();

	INIT_CLASS_ENTRY(ce, "GtkSheetRange", php_gtk_sheet_range_functions);
	gtk_sheet_range_ce = zend_register_internal_class_ex(&ce, NULL, NULL TSRMLS_CC);

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkPlot", php_gtk_plot_functions, NULL, NULL, php_gtk_set_property);
	gtk_plot_ce = zend_register_internal_class_ex(&ce, gtk_widget_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkPlot"), gtk_plot_ce);

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkPlotCanvas", php_gtk_plotcanvas_functions, NULL, NULL, php_gtk_set_property);
	gtk_plotcanvas_ce = zend_register_internal_class_ex(&ce, gtk_fixed_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkPlotCanvas"), gtk_plotcanvas_ce);

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkPlotData", php_gtk_plotdata_functions, NULL, NULL, php_gtk_set_property);
	gtk_plotdata_ce = zend_register_internal_class_ex(&ce, gtk_widget_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkPlotData"), gtk_plotdata_ce);

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkPlotAxis", php_gtk_plotaxis_functions, NULL, NULL, php_gtk_set_property);
	gtk_plotaxis_ce = zend_register_internal_class_ex(&ce, gtk_object_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkPlotAxis"), gtk_plotaxis_ce);

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkSheet", php_gtk_sheet_functions, NULL, NULL, php_gtk_set_property);
	gtk_sheet_ce = zend_register_internal_class_ex(&ce, gtk_container_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkSheet"), gtk_sheet_ce);


}

#endif /* HAVE_PHP_GTK */
